;;; -*- Mode: Emacs-Lisp -*-

;;; File:               sokoba-Xn.el
;;; Description:        Extension kit for sokoban.el
;;;
;;; Author:             Shigeki.Morimoto <mori@freedom.co.jp>
;;; Last Modified:      Sep 7, 1994
;;; Version:            0.3
;;;
;;;
;;; Ver 0.3 : Loop.
;;; Ver 0.2 : If (= start end) then man move.
;;; Ver 0.1 : Just make.

;; Copyright (C) 1994 Shigeki.Morimoto

(define-key sokoban-mode-map [drag-mouse-1] 'sokoban-X-mouse)
(define-key sokoban-mode-map [mouse-1] 'sokoban-X-mouse)
(defvar sokoban-X-ext-prog "/usr/local/bin/sk")

(defvar sokoban-X-proc nil)
(defvar sokoban-X-ret nil)

(defun sokoban-X-mouse (click)
  (interactive "e")
  (mouse-minibuffer-check click)
  (let ((start (posn-point (event-start click)))
        (end   (posn-point (event-end click)))
	x0 y0 x1 y1
	command
	)
    
    (message "Now thinking.")

    (save-excursion
      (goto-char start)
      (setq x0 (/ (current-column) sokoban-size))
      (setq y0 (1- (count-lines 1 (1+ start))))
      (goto-char end)
      (setq x1 (/ (current-column) sokoban-size))
      (setq y1 (1- (count-lines 1 (1+ end))))

      (setq command (concat (format "S: %d %d %d %d\n" x0 y0 x1 y1)
			    (buffer-substring (point-min) (point-max))
			    "E:\n"))

      (if (or (not (processp sokoban-X-proc))
	      (not (eq 'run (process-status sokoban-X-proc))))
	  (progn
	    (setq sokoban-X-proc (start-process "SK" nil sokoban-X-ext-prog))
	    (set-process-filter sokoban-X-proc 'sokoban-X-filter)
	    (process-kill-without-query sokoban-X-proc)))

      (setq sokoban-X-ret "")
      (process-send-string sokoban-X-proc command)

      (while (not (string-match "^E:" sokoban-X-ret))
	(accept-process-output sokoban-X-proc))
      ))
  (eval (car (read-from-string sokoban-X-ret)))
  (message "Done")
  )


(defun sokoban-X-filter (process out)
  (setq sokoban-X-ret (concat sokoban-X-ret out)))
